'--create objects
Set m_objNet=CreateObject("Wscript.Network")
Set m_objShell=CreateObject("Wscript.Shell")
Set m_objFS=CreateObject("Scripting.FileSystemObject")

'--get the gateway
Set m_objExec=m_objShell.Exec("powershell $(Get-NetRoute -DestinationPrefix 0.0.0.0/0).nexthop")
m_strTargetHost=Trim(m_objExec.StdOut.ReadLine)
If m_strTargetHost="" Then
	Wscript.Echo "Could not determine the default gateway. Other logging will continue."
	Wscript.Quit
End If

'--get this computer's name
m_strThisComputer=m_objNet.ComputerName

'--get the start time
m_strStartTime=Now()

'--set the log file
m_strLogParentFolder="logs - " & m_strThisComputer
Dim m_objLog
SetLogFile

'--init an array to hold results for the past 100 packets (-1 = null; 0 = reply; 1 = request timed out)
Dim m_nPacketArray(100)
For m_nCounter=0 To 99
	m_nPacketArray(m_nCounter) = -1 
Next

'--fix the packet size at 32 bytes
m_nPktSize=32

'--init packet tracking vars
m_nPktArrayIndex=-1
m_nHighLatencyCounter=0
m_nLatencySim=0
m_boolSimulatedLatency=False
m_boolProcessPings=False

'--start the ping command
Set m_objExec=m_objShell.Exec("ping -t -l " & m_nPktSize & " -f " & m_strTargetHost)

'--process and log the output
Do While Not m_objExec.StdOut.AtEndOfStream

	'--read a line of output from the ping command
	m_strLine=m_objExec.StdOut.ReadLine

	'--get the number of hours since the script started	
	m_intDateDiff=Abs(DateDiff("h",Now(),m_strStartTime))

	'--re-establish the log file (in case the date changed)
	SetLogFile

	'--start the ping processing loop if we have already seen the word "Pinging" in the command output
	If m_boolProcessPings=True Then

		'--increment the array index
		m_nPktArrayIndex=m_nPktArrayIndex+1
		If m_nPktArrayIndex > 99 Then
			m_nPktArrayIndex=0
		End If

		'///////////////////////////////////////////////////////
		'--simulate 10% loss by changing 10% of the lines to "Request timed out"
		'Dim m_nRandMax,m_nRandMin
 		'm_nRandMax=100
 		'm_nRandMin=1
 		'Randomize
 		'If Int((m_nRandMax-m_nRandMin+1)*Rnd+m_nRandMin) < 11 Then
		'	m_strLine="Request timed out"
		'End If

		'--set the array element value
		If Instr(m_strLine,"Request timed out") > 0 Then
			m_nPacketArray(m_nPktArrayIndex)=1
		Else
			m_nPacketArray(m_nPktArrayIndex)=0
		End If

		'--calculate the floating loss percentage
		m_LostPktCount=0
		For m_nCounter=0 To 99
			If m_nPacketArray(m_nCounter) >= 0 Then
				m_LostPktCount=m_LostPktCount+m_nPacketArray(m_nCounter)
			Else
				Exit For
			End If
		Next
		m_nPktLossPct=Round(m_LostPktCount/m_nCounter*100,2)

		'--get the latency
		If Instr(lCase(m_strLine),"reply from") > 0 Then		
			m_strResponseArray=Split(m_strLine," ")
			m_strLatencyElement=m_strResponseArray(4)
			m_strLatencyArray=Split(m_strLatencyElement,"=")
			m_strLatency=m_strLatencyArray(1)
			If Instr(m_strLatency,"ms") Then
				If Instr(m_strLatency,"<") Then
					m_nLatency=1
				Else
					m_nLatency=Left(m_strLatency,Len(m_strLatency)-2)
				End If
			Else
				m_strLatency=-1 '--error
			End If
		Else
			m_strLatency=-1 '--error
		End If

		'///////////////////////////////////////////////////////
		'--simulate high latency for 20 packets out of every 120
		'm_nLatencySim=m_nLatencySim+1
		'If m_nLatencySim > 120 Then
		'	m_nLatencySim=0
		'Else
		'	If m_nLatencySim < 21 Then
		'		m_boolSimulatedLatency=True
		'		m_nLatency=151
		'	Else
		'		m_boolSimulatedLatency=False
		'	End If
		'End If

		'--decide if a trace needs to be run
		If m_nLatency > 150 Then
			m_nHighLatencyCounter=m_nHighLatencyCounter+1
			If m_nHighLatencyCounter > 15 Then
				m_objShell.Run "c:\windows\system32\cscript _traceroute_small.vbs " & m_strTargetHost,0,False
			End If
		Else
			m_nHighLatencyCounter=0
		End If


	End If

	If m_boolProcessPings Then
		If m_boolSimulatedLatency Then
			m_objLog.WriteLine Now() & ": " & m_strLine & " (rolling loss=" & m_nPktLossPct & "%, sim latency=151ms)"
		Else
			m_objLog.WriteLine Now() & ": " & m_strLine & " (rolling loss=" & m_nPktLossPct & "%)"
		End If
	Else
		m_objLog.WriteLine Now() & ": " & m_strLine
	End if

	If Instr(m_strLine,"Pinging") > 0 Then
		m_boolProcessPings=True
	End if		
	
Loop

Sub SetLogFile()

	'--has the date changed?
	strNewLogDate=Year(Now()) & "-" & Month(Now()) & "-" & Day(Now())
	If strNewLogDate <> m_strLogDate Then

		'--set the current logging date
		m_strLogDate=strNewLogDate

		'--create a logs parent folder if necessary
		If Not m_objFS.FolderExists(m_strLogParentFolder) Then
			m_objFS.CreateFolder m_strLogParentFolder
		End If

		'--create a logs folder by date if necessary
		strLogFolder=m_strLogParentFolder & "\" & m_strLogDate
		If Not m_objFS.FolderExists(strLogFolder) Then
			m_objFS.CreateFolder strLogFolder
		End If

		'--create a new log object
		Set m_objLog=Nothing
		strLog=strLogFolder & "\ping_" & m_strTargetHost & "_small.txt"
		Set m_objLog=m_objFS.OpenTextFile(strLog,8,True)
	End If

End Sub